Understanding the monitoring.edgelq.com service APIv4, in proto package ntt.monitoring.v4.

Service monitoring.edgelq.com in version v4, proto package ntt.monitoring.v4

Here is the list of resources supported in Monitoring service APIv4:

Alert Resource

Alert Resource

Name patterns:

  • projects/{project}/regions/{region}/alertingPolicies/{alerting_policy}/alertingConditions/{alerting_condition}/alerts/{alert}

Parent resources:

This section covers the methods and messages to interact with Alert resource.

Alert Methods

Here is the list of Alert resource methods:

GetAlert Method

GetAlert

rpc GetAlert(GetAlertRequest) returns (Alert)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.get

The equivalent REST API is:

GET /v4/{name=projects/*/regions/*/alertingPolicies/*/alertingConditions/*/alerts/*} 

BatchGetAlerts Method

BatchGetAlerts

rpc BatchGetAlerts(BatchGetAlertsRequest) returns (BatchGetAlertsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.batchGet

The equivalent REST API is:

GET /v4/alerts:batchGet 

ListAlerts Method

ListAlerts

rpc ListAlerts(ListAlertsRequest) returns (ListAlertsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.list

The equivalent REST API is:

GET /v4/{parent=projects/*/regions/*/alertingPolicies/*/alertingConditions/*}/alerts 

WatchAlert Method

WatchAlert

rpc WatchAlert(WatchAlertRequest) returns (WatchAlertResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.watch

The equivalent REST API is:

POST /v4/{name=projects/*/regions/*/alertingPolicies/*/alertingConditions/*/alerts/*}:watch 

WatchAlerts Method

WatchAlerts

rpc WatchAlerts(WatchAlertsRequest) returns (WatchAlertsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.watch

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*/alertingPolicies/*/alertingConditions/*}/alerts:watch 

UpdateAlert Method

UpdateAlert

rpc UpdateAlert(UpdateAlertRequest) returns (Alert)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.update

The equivalent REST API is:

PUT /v4/{alert.name=projects/*/regions/*/alertingPolicies/*/alertingConditions/*/alerts/*} (BODY: alert)

DeleteAlert Method

DeleteAlert

rpc DeleteAlert(DeleteAlertRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.delete

The equivalent REST API is:

DELETE /v4/{name=projects/*/regions/*/alertingPolicies/*/alertingConditions/*/alerts/*} 

BulkCreateAlerts Method

BulkCreateAlerts

rpc BulkCreateAlerts(BulkCreateAlertsRequest) returns (BulkCreateAlertsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.bulkCreateAlerts

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*/alertingPolicies/*/alertingConditions/*}/alerts:bulkCreateAlerts 

BulkUpdateAlerts Method

BulkUpdateAlerts

rpc BulkUpdateAlerts(BulkUpdateAlertsRequest) returns (BulkUpdateAlertsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alerts.bulkUpdateAlerts

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*/alertingPolicies/*/alertingConditions/*}/alerts:bulkUpdateAlerts 

Alert Messages

Here is the list of Alert resource messages:

Alert Message

NameTypeDescription
namestring (name of Alert)Name of Alert When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-zA-Z0-9_.:-]{1,128}
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestring
infoAlert.Info
stateAlert.StateState of alert

Alert.Info Message

NameTypeDescription
time_serieAlert.Info.TimeSerieTimeSerie labels that violated condition. If Alert is for AlertingCondition using combine threshold, metric.type will be equal to primary metric indicated.
observed_valuesAlert.Info.ObservedValuesobserved time series values during alert creation

Alert.State Message

NameTypeDescription
is_firingbool
is_acknowledgedbool
is_silencedbool
lifetimeTimeRangedescribes in terms of time series when alert began and ended (resolved). uses Time Series derived timestamps, rather than real-time. use meta.create_time to get creation date.
needs_notificationboolThis alert needs to be notified
notification_createdboolNotification resource is generated for this alert
lifecycle_completedboolAlert has ended and any needed notifications are processed

Alert.Info.TimeSerie Message

NameTypeDescription
keybytes
metricMetric
monitored_resourceMonitoredResource
datarepeated stringInternal data for filtering…
bin_datarepeated bytes

Alert.Info.ObservedValues Message

NameTypeDescription
example_valuedoubleoneof
per_metricmap<string, double>

GetAlertRequest Message

A request message of the GetAlert method.

NameTypeDescription
namestring (name of Alert)Name of ntt.monitoring.v4.Alert
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetAlertsRequest Message

A request message of the BatchGetAlerts method.

NameTypeDescription
namesrepeated string (name of Alert)Names of Alerts
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetAlertsResponse Message

A response message of the BatchGetAlerts method.

NameTypeDescription
alertsrepeated Alertfound Alerts
missingrepeated string (name of Alert)list of not found Alerts

ListAlertsRequest Message

A request message of the ListAlerts method.

NameTypeDescription
parentstring (parent name of Alert)Parent name of ntt.monitoring.v4.Alert
page_sizeint32Requested page size. Server may return fewer Alerts than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of Alert)A token identifying a page of results the server should return. Typically, this is the value of ListAlertsResponse.next_page_token.
order_bystring (orderBy of Alert)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of Alert)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListAlertsResponse Message

A response message of the ListAlerts method.

NameTypeDescription
alertsrepeated AlertThe list of Alerts
prev_page_tokenstring (cursor of Alert)A token to retrieve previous page of results. Pass this value in the ListAlertsRequest.page_token.
next_page_tokenstring (cursor of Alert)A token to retrieve next page of results. Pass this value in the ListAlertsRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total Alerts across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchAlertRequest Message

A request message of the WatchAlert method.

NameTypeDescription
namestring (name of Alert)Name of ntt.monitoring.v4.Alert
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchAlertResponse Message

A response message of the WatchAlert method.

NameTypeDescription
changeAlertChange

WatchAlertsRequest Message

A request message of the WatchAlerts method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of Alert)Parent name of ntt.monitoring.v4.Alert
page_sizeint32Requested page size. Server may return fewer Alerts than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of Alert)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of Alert)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of Alert)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to Alert that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to Alert that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchAlertsResponse Message

A response message of the WatchAlerts method.

NameTypeDescription
alert_changesrepeated AlertChangeChanges of Alerts
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All Alerts will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchAlertsResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (Alerts will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchAlertsResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of Alert)New token to retrieve previous page of results.
next_page_tokenstring (cursor of Alert)New token to retrieve next page of results.

UpdateAlertRequest Message

A request message of the UpdateAlert method.

NameTypeDescription
alertAlertAlert resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateAlertRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
response_maskUpdateAlertRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

UpdateAlertRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateAlertConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateAlertRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteAlertRequest Message

A request message of the DeleteAlert method.

NameTypeDescription
namestring (name of Alert)Name of ntt.monitoring.v4.Alert
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

BulkCreateAlertsRequest Message

A request message of the BulkCreateAlerts method.

NameTypeDescription
parentstring (parent name of Alert)Parent name of ntt.monitoring.v4.Alert
alertsrepeated Alert

BulkCreateAlertsResponse Message

A response message of the BulkCreateAlerts method.

NameTypeDescription
nonenonenone

BulkUpdateAlertsRequest Message

A request message of the BulkUpdateAlerts method.

NameTypeDescription
parentstring (parent name of Alert)Parent name of ntt.monitoring.v4.Alert
update_mask.google.protobuf.FieldMask
alertsrepeated Alert

BulkUpdateAlertsResponse Message

A response message of the BulkUpdateAlerts method.

NameTypeDescription
nonenonenone

AlertingCondition Resource

AlertingCondition Resource

Name patterns:

  • projects/{project}/regions/{region}/alertingPolicies/{alerting_policy}/alertingConditions/{alerting_condition}

Parent resources:

This section covers the methods and messages to interact with AlertingCondition resource.

AlertingCondition Methods

Here is the list of AlertingCondition resource methods:

GetAlertingCondition Method

GetAlertingCondition

rpc GetAlertingCondition(GetAlertingConditionRequest) returns (AlertingCondition)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.get

The equivalent REST API is:

GET /v4/{name=projects/*/regions/*/alertingPolicies/*/alertingConditions/*} 

BatchGetAlertingConditions Method

BatchGetAlertingConditions

rpc BatchGetAlertingConditions(BatchGetAlertingConditionsRequest) returns (BatchGetAlertingConditionsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.batchGet

The equivalent REST API is:

GET /v4/alertingConditions:batchGet 

ListAlertingConditions Method

ListAlertingConditions

rpc ListAlertingConditions(ListAlertingConditionsRequest) returns (ListAlertingConditionsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.list

The equivalent REST API is:

GET /v4/{parent=projects/*/regions/*/alertingPolicies/*}/alertingConditions 

WatchAlertingCondition Method

WatchAlertingCondition

rpc WatchAlertingCondition(WatchAlertingConditionRequest) returns (WatchAlertingConditionResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.watch

The equivalent REST API is:

POST /v4/{name=projects/*/regions/*/alertingPolicies/*/alertingConditions/*}:watch 

WatchAlertingConditions Method

WatchAlertingConditions

rpc WatchAlertingConditions(WatchAlertingConditionsRequest) returns (WatchAlertingConditionsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.watch

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*/alertingPolicies/*}/alertingConditions:watch 

CreateAlertingCondition Method

CreateAlertingCondition

rpc CreateAlertingCondition(CreateAlertingConditionRequest) returns (AlertingCondition)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.create

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*/alertingPolicies/*}/alertingConditions (BODY: alerting_condition)

UpdateAlertingCondition Method

UpdateAlertingCondition

rpc UpdateAlertingCondition(UpdateAlertingConditionRequest) returns (AlertingCondition)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.update

The equivalent REST API is:

PUT /v4/{alerting_condition.name=projects/*/regions/*/alertingPolicies/*/alertingConditions/*} (BODY: alerting_condition)

DeleteAlertingCondition Method

DeleteAlertingCondition

rpc DeleteAlertingCondition(DeleteAlertingConditionRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.delete

The equivalent REST API is:

DELETE /v4/{name=projects/*/regions/*/alertingPolicies/*/alertingConditions/*} 

SearchAlertingConditions Method

SearchAlertingConditions

rpc SearchAlertingConditions(SearchAlertingConditionsRequest) returns (SearchAlertingConditionsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingConditions.search

The equivalent REST API is:

GET /v4/{parent=projects/*/regions/*/alertingPolicies/*}/alertingConditions:search 

AlertingCondition Messages

Here is the list of AlertingCondition resource messages:

AlertingCondition Message

NameTypeDescription
namestring (name of AlertingCondition)Name of AlertingCondition When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestringDisplay Name
descriptionstringLong description
specAlertingCondition.Spec
stateAlertingCondition.State

AlertingCondition.Spec Message

NameTypeDescription
time_seriesAlertingCondition.Spec.TimeSeries

AlertingCondition.State Message

NameTypeDescription
firing_alerts_countint64

AlertingCondition.Spec.TimeSeries Message

NameTypeDescription
queryAlertingCondition.Spec.TimeSeries.QueryTime Series Query
thresholdAlertingCondition.Spec.TimeSeries.ThresholdEither specify single threshold or combine threshold, which allows to pair each metric value to their specific thresholds, e.g. distinguish mean (loss, latency, jitter) in single query. If combine threshold is used, alert will be triggered only when all thresholds are violated. Example use case: * Trigger alert when CPU utilization > … and uptime > … (so we dont alert during startup unnecessarily). Time series sharing same fields except metric.type are merged (originally determined by aggregation.groupByFields).
combine_thresholdAlertingCondition.Spec.TimeSeries.CombineThreshold
duration.google.protobuf.DurationDuration describes length of time needed for the condition to trigger a new alert of resolve an existing one

AlertingCondition.Spec.TimeSeries.Query Message

NameTypeDescription
filterstring (filter of TimeSerie)Filter used for time-series.
selectorTimeSeriesSelectorGenerated, filter-able selector, extracted from filter value. It will contain all extracted conditions for ‘==’ and ‘IN’ operators. It will exclude conditions for operators ‘!=’ and ‘NOT IN’. This allows filtering AlertingConditions by filter conditions.
aggregationAggregationTime Series aggregation. In case of combine threshold, it is used by “main” metric.type, and additional metric types if overrides are not specified.
per_metric_aggregationsmap<string, Aggregation>If metric.type uses CombineThreshold and multiple metrics, it can provide extra per metric aggregation override. This cannot be specified for “main” metric.type. But be aware, AP and GroupByFields must be exactly same as in “aggregation” field.

AlertingCondition.Spec.TimeSeries.Threshold Message

NameTypeDescription
compareAlertingCondition.Spec.TimeSeries.Threshold.CompareCompare function specifies if observed value must be GreaterThan (GT) or LesserThan (LT) threshold value in order to trigger an alert. Example: for metric latency {compare: GT, value: 150} will trigger if actual latency is above 150ms.
valuedoublethreshold value

AlertingCondition.Spec.TimeSeries.CombineThreshold Message

NameTypeDescription
per_metricmap<string, AlertingCondition.Spec.TimeSeries.Threshold>Per Metric threshold. If multiple metrics are selected each metric may specify a different threshold
main_metric_typestringPrimary metric.type for this condition. Although Alerts generated across multiple metric.type are possible, Alert instance has single “info.time_serie.metric.type” field path value.
per_metric_type_kvmap<string, bytes>Internal per metric identifiers in binary key

GetAlertingConditionRequest Message

A request message of the GetAlertingCondition method.

NameTypeDescription
namestring (name of AlertingCondition)Name of ntt.monitoring.v4.AlertingCondition
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetAlertingConditionsRequest Message

A request message of the BatchGetAlertingConditions method.

NameTypeDescription
namesrepeated string (name of AlertingCondition)Names of AlertingConditions
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetAlertingConditionsResponse Message

A response message of the BatchGetAlertingConditions method.

NameTypeDescription
alerting_conditionsrepeated AlertingConditionfound AlertingConditions
missingrepeated string (name of AlertingCondition)list of not found AlertingConditions

ListAlertingConditionsRequest Message

A request message of the ListAlertingConditions method.

NameTypeDescription
parentstring (parent name of AlertingCondition)Parent name of ntt.monitoring.v4.AlertingCondition
page_sizeint32Requested page size. Server may return fewer AlertingConditions than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of AlertingCondition)A token identifying a page of results the server should return. Typically, this is the value of ListAlertingConditionsResponse.next_page_token.
order_bystring (orderBy of AlertingCondition)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of AlertingCondition)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListAlertingConditionsResponse Message

A response message of the ListAlertingConditions method.

NameTypeDescription
alerting_conditionsrepeated AlertingConditionThe list of AlertingConditions
prev_page_tokenstring (cursor of AlertingCondition)A token to retrieve previous page of results. Pass this value in the ListAlertingConditionsRequest.page_token.
next_page_tokenstring (cursor of AlertingCondition)A token to retrieve next page of results. Pass this value in the ListAlertingConditionsRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total AlertingConditions across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchAlertingConditionRequest Message

A request message of the WatchAlertingCondition method.

NameTypeDescription
namestring (name of AlertingCondition)Name of ntt.monitoring.v4.AlertingCondition
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchAlertingConditionResponse Message

A response message of the WatchAlertingCondition method.

NameTypeDescription
changeAlertingConditionChange

WatchAlertingConditionsRequest Message

A request message of the WatchAlertingConditions method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of AlertingCondition)Parent name of ntt.monitoring.v4.AlertingCondition
page_sizeint32Requested page size. Server may return fewer AlertingConditions than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of AlertingCondition)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of AlertingCondition)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of AlertingCondition)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to AlertingCondition that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to AlertingCondition that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchAlertingConditionsResponse Message

A response message of the WatchAlertingConditions method.

NameTypeDescription
alerting_condition_changesrepeated AlertingConditionChangeChanges of AlertingConditions
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All AlertingConditions will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchAlertingConditionsResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (AlertingConditions will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchAlertingConditionsResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of AlertingCondition)New token to retrieve previous page of results.
next_page_tokenstring (cursor of AlertingCondition)New token to retrieve next page of results.

CreateAlertingConditionRequest Message

A request message of the CreateAlertingCondition method.

NameTypeDescription
parentstring (parent name of AlertingCondition)Parent name of ntt.monitoring.v4.AlertingCondition
alerting_conditionAlertingConditionAlertingCondition resource body
response_maskCreateAlertingConditionRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateAlertingConditionRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateAlertingConditionRequest Message

A request message of the UpdateAlertingCondition method.

NameTypeDescription
alerting_conditionAlertingConditionAlertingCondition resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateAlertingConditionRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateAlertingConditionRequest.ResponseMaskreduce message response size.

UpdateAlertingConditionRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateAlertingConditionConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateAlertingConditionRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteAlertingConditionRequest Message

A request message of the DeleteAlertingCondition method.

NameTypeDescription
namestring (name of AlertingCondition)Name of ntt.monitoring.v4.AlertingCondition
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

SearchAlertingConditionsRequest Message

A request message of the SearchAlertingConditions method.

NameTypeDescription
parentstring (parent name of AlertingCondition)Parent name of ntt.monitoring.v4.AlertingCondition
page_sizeint32Requested page size. Server may return fewer AlertingConditions than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of AlertingCondition)A token identifying a page of results the server should return. Typically, this is the value of SearchAlertingConditionsResponse.next_page_token.
order_bystring (orderBy of AlertingCondition)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of AlertingCondition)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
phrasestringOptional search phrase used to further filter results.

SearchAlertingConditionsResponse Message

A response message of the SearchAlertingConditions method.

NameTypeDescription
alerting_conditionsrepeated AlertingConditionThe list of AlertingConditions
prev_page_tokenstring (cursor of AlertingCondition)A token to retrieve previous page of results. Pass this value in the SearchAlertingConditionsRequest.page_token.
next_page_tokenstring (cursor of AlertingCondition)A token to retrieve next page of results. Pass this value in the SearchAlertingConditionsRequest.page_token.
current_offsetint32Current offset from the first page (0 if no page tokens were given). Page index can be computed from offset and limit provided in a request
total_results_countint32Number of total AlertingConditions across all pages.

AlertingCondition Enumerations

Here is the list of AlertingCondition resource enumerations:

AlertingCondition.Spec.TimeSeries.Threshold.Compare Enumeration

NameDescription
COMPARE_UNSPECIFIED
GT
LT

AlertingPolicy Resource

AlertingPolicy Resource

Name patterns:

  • projects/{project}/regions/{region}/alertingPolicies/{alerting_policy}

Parent resources:

This section covers the methods and messages to interact with AlertingPolicy resource.

AlertingPolicy Methods

Here is the list of AlertingPolicy resource methods:

GetAlertingPolicy Method

GetAlertingPolicy

rpc GetAlertingPolicy(GetAlertingPolicyRequest) returns (AlertingPolicy)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.get

The equivalent REST API is:

GET /v4/{name=projects/*/regions/*/alertingPolicies/*} 

BatchGetAlertingPolicies Method

BatchGetAlertingPolicies

rpc BatchGetAlertingPolicies(BatchGetAlertingPoliciesRequest) returns (BatchGetAlertingPoliciesResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.batchGet

The equivalent REST API is:

GET /v4/alertingPolicies:batchGet 

ListAlertingPolicies Method

ListAlertingPolicies

rpc ListAlertingPolicies(ListAlertingPoliciesRequest) returns (ListAlertingPoliciesResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.list

The equivalent REST API is:

GET /v4/{parent=projects/*/regions/*}/alertingPolicies 

WatchAlertingPolicy Method

WatchAlertingPolicy

rpc WatchAlertingPolicy(WatchAlertingPolicyRequest) returns (WatchAlertingPolicyResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.watch

The equivalent REST API is:

POST /v4/{name=projects/*/regions/*/alertingPolicies/*}:watch 

WatchAlertingPolicies Method

WatchAlertingPolicies

rpc WatchAlertingPolicies(WatchAlertingPoliciesRequest) returns (WatchAlertingPoliciesResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.watch

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*}/alertingPolicies:watch 

CreateAlertingPolicy Method

CreateAlertingPolicy

rpc CreateAlertingPolicy(CreateAlertingPolicyRequest) returns (AlertingPolicy)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.create

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*}/alertingPolicies (BODY: alerting_policy)

UpdateAlertingPolicy Method

UpdateAlertingPolicy

rpc UpdateAlertingPolicy(UpdateAlertingPolicyRequest) returns (AlertingPolicy)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.update

The equivalent REST API is:

PUT /v4/{alerting_policy.name=projects/*/regions/*/alertingPolicies/*} (BODY: alerting_policy)

DeleteAlertingPolicy Method

DeleteAlertingPolicy

rpc DeleteAlertingPolicy(DeleteAlertingPolicyRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.delete

The equivalent REST API is:

DELETE /v4/{name=projects/*/regions/*/alertingPolicies/*} 

SearchAlertingPolicies Method

SearchAlertingPolicies

rpc SearchAlertingPolicies(SearchAlertingPoliciesRequest) returns (SearchAlertingPoliciesResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/alertingPolicies.search

The equivalent REST API is:

GET /v4/{parent=projects/*/regions/*}/alertingPolicies:search 

AlertingPolicy Messages

Here is the list of AlertingPolicy resource messages:

AlertingPolicy Message

NameTypeDescription
namestring (name of AlertingPolicy)Name of AlertingPolicy When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestringdisplay name
descriptionstringLong description
documentationAlertingPolicy.Documentation
specAlertingPolicy.SpecSpec
stateAlertingPolicy.State

AlertingPolicy.Documentation Message

Documentation

NameTypeDescription
contentstringDocumentation content
mime_typestringdocumentation mime type. Only "text/markdown" is supported.

AlertingPolicy.Spec Message

NameTypeDescription
enabledboolWhether policy is enabled and will evaluate any conditions Note: If any existing fired alerts are present, they will not be resolved automatically TODO: consider if they should?
condition_combinerAlertingPolicy.Spec.ConditionsCombinerCondition Combiner when deciding if ANY (OR) or ALL (AND) conditions for given subset of resource labels must fire in order to trigger an alert TODO: Add support to AND
notificationAlertingPolicy.Spec.NotificationNotification specification

AlertingPolicy.State Message

NameTypeDescription
active_alerts_countint64Number of ongoing alerts (incident has not ended)

AlertingPolicy.Spec.Notification Message

Notification specification for a given Policy

NameTypeDescription
enabledboolEnabled flag determines whether any notifications will be sent
channelsrepeated string (reference to NotificationChannel)

GetAlertingPolicyRequest Message

A request message of the GetAlertingPolicy method.

NameTypeDescription
namestring (name of AlertingPolicy)Name of ntt.monitoring.v4.AlertingPolicy
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetAlertingPoliciesRequest Message

A request message of the BatchGetAlertingPolicies method.

NameTypeDescription
namesrepeated string (name of AlertingPolicy)Names of AlertingPolicies
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetAlertingPoliciesResponse Message

A response message of the BatchGetAlertingPolicies method.

NameTypeDescription
alerting_policiesrepeated AlertingPolicyfound AlertingPolicies
missingrepeated string (name of AlertingPolicy)list of not found AlertingPolicies

ListAlertingPoliciesRequest Message

A request message of the ListAlertingPolicies method.

NameTypeDescription
parentstring (parent name of AlertingPolicy)Parent name of ntt.monitoring.v4.AlertingPolicy
page_sizeint32Requested page size. Server may return fewer AlertingPolicies than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of AlertingPolicy)A token identifying a page of results the server should return. Typically, this is the value of ListAlertingPoliciesResponse.next_page_token.
order_bystring (orderBy of AlertingPolicy)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of AlertingPolicy)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListAlertingPoliciesResponse Message

A response message of the ListAlertingPolicies method.

NameTypeDescription
alerting_policiesrepeated AlertingPolicyThe list of AlertingPolicies
prev_page_tokenstring (cursor of AlertingPolicy)A token to retrieve previous page of results. Pass this value in the ListAlertingPoliciesRequest.page_token.
next_page_tokenstring (cursor of AlertingPolicy)A token to retrieve next page of results. Pass this value in the ListAlertingPoliciesRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total AlertingPolicies across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchAlertingPolicyRequest Message

A request message of the WatchAlertingPolicy method.

NameTypeDescription
namestring (name of AlertingPolicy)Name of ntt.monitoring.v4.AlertingPolicy
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchAlertingPolicyResponse Message

A response message of the WatchAlertingPolicy method.

NameTypeDescription
changeAlertingPolicyChange

WatchAlertingPoliciesRequest Message

A request message of the WatchAlertingPolicies method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of AlertingPolicy)Parent name of ntt.monitoring.v4.AlertingPolicy
page_sizeint32Requested page size. Server may return fewer AlertingPolicies than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of AlertingPolicy)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of AlertingPolicy)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of AlertingPolicy)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to AlertingPolicy that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to AlertingPolicy that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchAlertingPoliciesResponse Message

A response message of the WatchAlertingPolicies method.

NameTypeDescription
alerting_policy_changesrepeated AlertingPolicyChangeChanges of AlertingPolicies
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All AlertingPolicies will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchAlertingPoliciesResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (AlertingPolicies will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchAlertingPoliciesResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of AlertingPolicy)New token to retrieve previous page of results.
next_page_tokenstring (cursor of AlertingPolicy)New token to retrieve next page of results.

CreateAlertingPolicyRequest Message

A request message of the CreateAlertingPolicy method.

NameTypeDescription
parentstring (parent name of AlertingPolicy)Parent name of ntt.monitoring.v4.AlertingPolicy
alerting_policyAlertingPolicyAlertingPolicy resource body
response_maskCreateAlertingPolicyRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateAlertingPolicyRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateAlertingPolicyRequest Message

A request message of the UpdateAlertingPolicy method.

NameTypeDescription
alerting_policyAlertingPolicyAlertingPolicy resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateAlertingPolicyRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateAlertingPolicyRequest.ResponseMaskreduce message response size.

UpdateAlertingPolicyRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateAlertingPolicyConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateAlertingPolicyRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteAlertingPolicyRequest Message

A request message of the DeleteAlertingPolicy method.

NameTypeDescription
namestring (name of AlertingPolicy)Name of ntt.monitoring.v4.AlertingPolicy
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

SearchAlertingPoliciesRequest Message

A request message of the SearchAlertingPolicies method.

NameTypeDescription
parentstring (parent name of AlertingPolicy)Parent name of ntt.monitoring.v4.AlertingPolicy
page_sizeint32Requested page size. Server may return fewer AlertingPolicies than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of AlertingPolicy)A token identifying a page of results the server should return. Typically, this is the value of SearchAlertingPoliciesResponse.next_page_token.
order_bystring (orderBy of AlertingPolicy)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of AlertingPolicy)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
phrasestringOptional search phrase used to further filter results.

SearchAlertingPoliciesResponse Message

A response message of the SearchAlertingPolicies method.

NameTypeDescription
alerting_policiesrepeated AlertingPolicyThe list of AlertingPolicies
prev_page_tokenstring (cursor of AlertingPolicy)A token to retrieve previous page of results. Pass this value in the SearchAlertingPoliciesRequest.page_token.
next_page_tokenstring (cursor of AlertingPolicy)A token to retrieve next page of results. Pass this value in the SearchAlertingPoliciesRequest.page_token.
current_offsetint32Current offset from the first page (0 if no page tokens were given). Page index can be computed from offset and limit provided in a request
total_results_countint32Number of total AlertingPolicies across all pages.

AlertingPolicy Enumerations

Here is the list of AlertingPolicy resource enumerations:

AlertingPolicy.Spec.ConditionsCombiner Enumeration

NameDescription
OR
AND

Bucket Resource

Bucket Resource restricts create/list time series requests to the specified metric/resource types.

Name patterns:

  • projects/{project}/regions/{region}/buckets/{bucket}

Parent resources:

This section covers the methods and messages to interact with Bucket resource.

Bucket Methods

Here is the list of Bucket resource methods:

GetBucket Method

GetBucket

rpc GetBucket(GetBucketRequest) returns (Bucket)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/buckets.get

The equivalent REST API is:

GET /v4/{name=projects/*/regions/*/buckets/*} 

BatchGetBuckets Method

BatchGetBuckets

rpc BatchGetBuckets(BatchGetBucketsRequest) returns (BatchGetBucketsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/buckets.batchGet

The equivalent REST API is:

GET /v4/buckets:batchGet 

ListBuckets Method

ListBuckets

rpc ListBuckets(ListBucketsRequest) returns (ListBucketsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/buckets.list

The equivalent REST API is:

GET /v4/{parent=projects/*/regions/*}/buckets 

WatchBucket Method

WatchBucket

rpc WatchBucket(WatchBucketRequest) returns (WatchBucketResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/buckets.watch

The equivalent REST API is:

POST /v4/{name=projects/*/regions/*/buckets/*}:watch 

WatchBuckets Method

WatchBuckets

rpc WatchBuckets(WatchBucketsRequest) returns (WatchBucketsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/buckets.watch

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*}/buckets:watch 

CreateBucket Method

CreateBucket

rpc CreateBucket(CreateBucketRequest) returns (Bucket)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/buckets.create

The equivalent REST API is:

POST /v4/{parent=projects/*/regions/*}/buckets (BODY: bucket)

UpdateBucket Method

UpdateBucket

rpc UpdateBucket(UpdateBucketRequest) returns (Bucket)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/buckets.update

The equivalent REST API is:

PUT /v4/{bucket.name=projects/*/regions/*/buckets/*} (BODY: bucket)

DeleteBucket Method

DeleteBucket

rpc DeleteBucket(DeleteBucketRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/buckets.delete

The equivalent REST API is:

DELETE /v4/{name=projects/*/regions/*/buckets/*} 

Bucket Messages

Here is the list of Bucket resource messages:

Bucket Message

NameTypeDescription
namestring (name of Bucket)Name of Bucket When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [\w./-]{2,128}
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
metricsrepeated Bucket.RequiredTypedLabelsAllowed metric combinations (OR). If empty, all metric types are allowed.
resourcesrepeated Bucket.RequiredTypedLabelsAllowed resource combinations (OR).If empty, all resource types are allowed.
required_alt_kvsrepeated Bucket.ResolvedKeysWithValuesAll combinations of key-values (in integer forms) - one of them must be passed by every TimeSerie object for given bucket. Its computed by server side and for internal use.

Bucket.ResolvedValues Message

ResolvedValues contains binary representation of types and labels and possible values. Due to limitations in some db backends (looking at firestore), we use int64 instead of uint64.

NameTypeDescription
keyint64
valuesrepeated int64

Bucket.ResolvedKeysWithValues Message

ResolvedKeysWithValues binds multiple keys with possible values.

NameTypeDescription
resolved_kvsrepeated Bucket.ResolvedValues

Bucket.RequiredTypedLabels Message

RequiredTypedLabels describes required label values for specified metric and resource types. All time series in Create operation must contain at least one allowed type and then labels must match all the labels. For list queries, filter must contain at least one type and all labels must be present in condition containing all or subset of allowed label values.

NameTypeDescription
typesrepeated string
labelsmap<string, Bucket.RequiredTypedLabels.Strings>

Bucket.RequiredTypedLabels.Strings Message

NameTypeDescription
stringsrepeated string

GetBucketRequest Message

A request message of the GetBucket method.

NameTypeDescription
namestring (name of Bucket)Name of ntt.monitoring.v4.Bucket
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetBucketsRequest Message

A request message of the BatchGetBuckets method.

NameTypeDescription
namesrepeated string (name of Bucket)Names of Buckets
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetBucketsResponse Message

A response message of the BatchGetBuckets method.

NameTypeDescription
bucketsrepeated Bucketfound Buckets
missingrepeated string (name of Bucket)list of not found Buckets

ListBucketsRequest Message

A request message of the ListBuckets method.

NameTypeDescription
parentstring (parent name of Bucket)Parent name of ntt.monitoring.v4.Bucket
page_sizeint32Requested page size. Server may return fewer Buckets than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of Bucket)A token identifying a page of results the server should return. Typically, this is the value of ListBucketsResponse.next_page_token.
order_bystring (orderBy of Bucket)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of Bucket)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListBucketsResponse Message

A response message of the ListBuckets method.

NameTypeDescription
bucketsrepeated BucketThe list of Buckets
prev_page_tokenstring (cursor of Bucket)A token to retrieve previous page of results. Pass this value in the ListBucketsRequest.page_token.
next_page_tokenstring (cursor of Bucket)A token to retrieve next page of results. Pass this value in the ListBucketsRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total Buckets across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchBucketRequest Message

A request message of the WatchBucket method.

NameTypeDescription
namestring (name of Bucket)Name of ntt.monitoring.v4.Bucket
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchBucketResponse Message

A response message of the WatchBucket method.

NameTypeDescription
changeBucketChange

WatchBucketsRequest Message

A request message of the WatchBuckets method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of Bucket)Parent name of ntt.monitoring.v4.Bucket
page_sizeint32Requested page size. Server may return fewer Buckets than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of Bucket)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of Bucket)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of Bucket)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to Bucket that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to Bucket that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchBucketsResponse Message

A response message of the WatchBuckets method.

NameTypeDescription
bucket_changesrepeated BucketChangeChanges of Buckets
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All Buckets will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchBucketsResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (Buckets will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchBucketsResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of Bucket)New token to retrieve previous page of results.
next_page_tokenstring (cursor of Bucket)New token to retrieve next page of results.

CreateBucketRequest Message

A request message of the CreateBucket method.

NameTypeDescription
parentstring (parent name of Bucket)Parent name of ntt.monitoring.v4.Bucket
bucketBucketBucket resource body
response_maskCreateBucketRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateBucketRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateBucketRequest Message

A request message of the UpdateBucket method.

NameTypeDescription
bucketBucketBucket resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateBucketRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateBucketRequest.ResponseMaskreduce message response size.

UpdateBucketRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateBucketConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateBucketRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteBucketRequest Message

A request message of the DeleteBucket method.

NameTypeDescription
namestring (name of Bucket)Name of ntt.monitoring.v4.Bucket
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

MetricDescriptor Resource

Defines a metric type and its schema. Once a metric descriptor is created, deleting or altering it stops data collection and makes the metric type’s existing data unusable.

Name patterns:

  • projects/{project}/metricDescriptors/{metric_descriptor}

Parent resources:

This section covers the methods and messages to interact with MetricDescriptor resource.

MetricDescriptor Methods

Here is the list of MetricDescriptor resource methods:

BatchGetMetricDescriptors Method

BatchGetMetricDescriptors

rpc BatchGetMetricDescriptors(BatchGetMetricDescriptorsRequest) returns (BatchGetMetricDescriptorsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/metricDescriptors.batchGet

The equivalent REST API is:

GET /v4/metricDescriptors:batchGet 

WatchMetricDescriptor Method

WatchMetricDescriptor

rpc WatchMetricDescriptor(WatchMetricDescriptorRequest) returns (WatchMetricDescriptorResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/metricDescriptors.watch

The equivalent REST API is:

POST /v4/{name=projects/*/metricDescriptors/*}:watch 

WatchMetricDescriptors Method

WatchMetricDescriptors

rpc WatchMetricDescriptors(WatchMetricDescriptorsRequest) returns (WatchMetricDescriptorsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/metricDescriptors.watch

The equivalent REST API is:

POST /v4/{parent=projects/*}/metricDescriptors:watch 

GetMetricDescriptor Method

GetMetricDescriptor

rpc GetMetricDescriptor(GetMetricDescriptorRequest) returns (MetricDescriptor)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/metricDescriptors.get

The equivalent REST API is:

GET /v4/{name=projects/*/metricDescriptors/*} 

CreateMetricDescriptor Method

CreateMetricDescriptor

rpc CreateMetricDescriptor(CreateMetricDescriptorRequest) returns (MetricDescriptor)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/metricDescriptors.create

The equivalent REST API is:

POST /v4/{parent=projects/*}/metricDescriptors (BODY: metric_descriptor)

UpdateMetricDescriptor Method

UpdateMetricDescriptor

rpc UpdateMetricDescriptor(UpdateMetricDescriptorRequest) returns (MetricDescriptor)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/metricDescriptors.update

The equivalent REST API is:

PUT /v4/{metric_descriptor.name=projects/*/metricDescriptors/*} (BODY: metric_descriptor)

DeleteMetricDescriptor Method

DeleteMetricDescriptor

rpc DeleteMetricDescriptor(DeleteMetricDescriptorRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/metricDescriptors.delete

The equivalent REST API is:

DELETE /v4/{name=projects/*/metricDescriptors/*} 

ListMetricDescriptors Method

ListMetricDescriptors

rpc ListMetricDescriptors(ListMetricDescriptorsRequest) returns (ListMetricDescriptorsResponse)

with the following messages:

Required Permissions:

  • services/monitoring.edgelq.com/permissions/metricDescriptors.list

The equivalent REST API is:

GET /v4/{parent=projects/*}/metricDescriptors 

MetricDescriptor Messages

Here is the list of MetricDescriptor resource messages:

MetricDescriptor Message

NameTypeDescription
namestring (name of MetricDescriptor)Name of MetricDescriptor When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [\w./-]{4,128}
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
typestringThe metric type, including its DNS name prefix. The type is not URL-encoded. All user-defined metric types have the DNS name custom.googleapis.com or external.googleapis.com. Metric types should use a natural hierarchical grouping. For example: “custom.googleapis.com/invoice/paid/amount” “external.googleapis.com/prometheus/up” “appengine.googleapis.com/http/server/response_latencies”
resource_typesrepeated stringassociated resource_types (also used to infer defaults) examples, devices.edgelq.com/Device, watchdog.edgelq.com/Agent. DEPRECATED, use “indices”.
labelsrepeated LabelDescriptorThe set of labels that can be used to describe a specific instance of this metric type. For example, the appengine.googleapis.com/http/server/response_latencies metric type has a label for the HTTP response code, response_code, so you can look at latencies for successful responses or just for responses that failed.
metric_kindMetricDescriptor.MetricKindWhether the metric records instantaneous values, changes to a value, etc. Some combinations of metric_kind and value_type might not be supported.
value_typeMetricDescriptor.ValueTypeWhether the measurement is an integer, a floating-point number, etc. Some combinations of metric_kind and value_type might not be supported.
unitstringThe unit in which the metric value is reported. It is only applicable if the value_type is INT64, DOUBLE, or DISTRIBUTION. The supported units are a subset of The Unified Code for Units of Measure standard: Basic units (UNIT) * bit bit * By byte * s second * min minute * h hour * d day Prefixes (PREFIX) * k kilo (103) * M mega (106) * G giga (109) * T tera (1012) * P peta (1015) * E exa (1018) * Z zetta (1021) * Y yotta (1024) * m milli (10**-3) * u micro (10**-6) * n nano (10**-9) * p pico (10**-12) * f femto (10**-15) * a atto (10**-18) * z zepto (10**-21) * y yocto (10**-24) * Ki kibi (210) * Mi mebi (220) * Gi gibi (230) * Ti tebi (240) Grammar The grammar also includes these connectors: * / division (as an infix operator, e.g. 1/s). * . multiplication (as an infix operator, e.g. GBy.d) The grammar for a unit is as follows: Expression = Component { “.” Component } { “/” Component } ; Component = ( [ PREFIX ] UNIT
descriptionstringA detailed description of the metric, which can be used in documentation.
display_namestringA concise name for the metric, which can be displayed in user interfaces. Use sentence case without an ending period, for example “Request count”. This field is optional but it is recommended to be set for any metrics associated with user-visible concepts, such as Quota.
metric_descriptor_metadataMetricDescriptor.MetricDescriptorMetadataOptional. Metadata which can be used to guide usage of the metric.
distribution_bucket_optionsDistribution.BucketOptionsDistribution bucketing options - define only when ValueType is Distribution. Used for validating input.
promoted_label_key_setsrepeated LabelKeySetPromoted Label Key Sets allow defining multiple indexing rules for underlying backend enabling query optimizations. Metric promoted label sets are combined with MonitoredResource promoted label sets and result in PromotedKeySet. DEPRECATED, use “indices” instead.
index_specMetricDescriptor.IndexSpecDEPRECATED: use “indices”. This field must not be used if client migrated to ResourceBindings. Whenever index_spec is set, it will override resource_descriptor_bindings. This is for migration purpose, future indices must be managed by ResourceBindings.
indicesMetricDescriptor.IndicesDefines indexing rules for underlying backend enabling query optimizations. It’s important consideration for balancing time series query performance and storage cost. Number of non-disabled indices per resource type is 64. Indices are generated from index families. Final index is a combination of metric & resource promoted label set, and pre-aggregation spec (if any). For example, index family with 2 promoted sets for resource, 3 promoted sets for metric, 2 pre-aggregations would create 12 indices. If no pre-aggregations were defined, it would be 6 indices. Metric and resource label sets must never be empty: At least one empty label set must be present.
storage_configMetricDescriptor.StorageConfigStorage settings
binary_indicesMetricDescriptor.BinaryIndicesGenerated indices data in binary format, for internal use only. They are compiled when MetricDescriptor is saved and used by monitoring server, db-controller or controller when necessary. One MetricDescriptor instance will have different value of this field in each region!

MetricDescriptor.MetricDescriptorMetadata Message

Additional annotations that can be used to guide the usage of a metric.

NameTypeDescription
launch_stageLaunchStageThe launch stage of the metric definition.

MetricDescriptor.IndexSpec Message

DEPRECATED, use Indices

NameTypeDescription
per_resourcerepeated MetricDescriptor.IndexSpec.PerMonitoredResourcePerResource index

MetricDescriptor.Indices Message

ResourceBindings binds MetricDescriptor with selected MonitoredResourceDescriptors and provides indices for TimeSeries storage.

NameTypeDescription
built_inMetricDescriptor.Indices.IndexGroupsIndices coming by default from application, typically populated by fixtures controller
user_definedMetricDescriptor.Indices.IndexGroupsUser defined additional indices.
legacy_migratedrepeated MetricDescriptor.Indices.NonAggregatedIndicesAutomatically migrated from older specs. It should not be modified by users, it can only be archived once new indices are populated (update closingStatus fields to CLOSED).

MetricDescriptor.StorageConfig Message

Backend storage config

NameTypeDescription
store_raw_pointsboolwhether to store raw points
max_ap.google.protobuf.DurationMaximum AlignmentPeriod produced. If max_ap is 0, then it is treated as no maximum. Monitoring will be producing time series for all alignment periods. If max_ap is 1 minute, it means only the smallest alignment period is produced.

MetricDescriptor.BinaryIndices Message

NameTypeDescription
by_resourcesrepeated MetricDescriptor.BinaryIndices.ByResourceType
regionstringRegion to which above binary data is relevant.

MetricDescriptor.IndexSpec.Index Message

NameTypeDescription
promoted_labelsrepeated stringeach label is of format: {metric,resource}.labels.\<label-key\>. since resource and metric labels are mixed. Full path is required.

MetricDescriptor.IndexSpec.PerMonitoredResource Message

NameTypeDescription
resourcestring (reference to MonitoredResourceDescriptor)
indicesrepeated MetricDescriptor.IndexSpec.IndexList of indices for given metric and resource pair

MetricDescriptor.Indices.LabelsGroup Message

LabelsGroup represents set of labels in resource and metric. It forms part of the index generators (non and pre aggregated).

NameTypeDescription
namestringIdentifier of the group, used as part of index name and during update validations.
metric_keysrepeated stringList of metric keys in the group.
resource_keysrepeated stringList of resource keys in the group.
closing_statusMetricDescriptor.Indices.CloseStatusClosing status should be set when indices used by this group is no longer desirable.

MetricDescriptor.Indices.PaginationView Message

PaginationView is used by PaginationIndices. It indicates which labels in metric/resource descriptor are kept for filter purpose, and which are “ranked” by.

NameTypeDescription
namestringIdentifier of the group, used as part of index name and during update validations.
filterable_metric_keysrepeated stringList of metric keys that can optionally be used in filter.
filterable_resource_keysrepeated stringList of resource keys that can optionally be used in filter.
paginated_metric_keysrepeated stringList of metric keys that will be part of “paginated” key (for ranking purpose). Provided labels cannot be used for filtering.
paginated_resource_keysrepeated stringList of resource keys that will be part of “paginated” key (for ranking purpose). Provided labels cannot be used for filtering.
closing_statusMetricDescriptor.Indices.CloseStatusClosing status should be set when indices used by this group is no longer desirable.

MetricDescriptor.Indices.AggregationsGroup Message

AggregationsGroup groups aggregations required for pre-aggregated indices.

NameTypeDescription
namestringName of the group (identifier). Used for validating updates.
per_series_alignersrepeated Aggregation.AlignerList of potential values for perSeriesAligner parameter. It must be specified.
cross_series_reducersrepeated Aggregation.ReducerList of potential values for crossSeriesReducer parameter. It can be left empty if we want to support large amount of values.
closing_statusMetricDescriptor.Indices.CloseStatusClosing status, if this group is no longer desired.
storage_alignersrepeated Aggregation.AlignerThis field is automatically computed and cannot be set by users. It displays list of aligners used by underlying storage. May not exactly match to requested aligners. TODO: Support output_only annotation for sub-array items

MetricDescriptor.Indices.SortingFunction Message

SortingFunction is a function used for paginable indices.

NameTypeDescription
namestringname of the aligner-reducer function
alignerAggregation.AlignerAligner function
reducerAggregation.ReducerReducer function, merging values within paginable label set. Resulting value type must be either INT or DOUBLE, DISTRIBUTION is not supported.
closing_statusMetricDescriptor.Indices.CloseStatusClosing status of this aligner reducer function.
sortingMetricDescriptor.Indices.SortingFunction.Direction

MetricDescriptor.Indices.PreAggregatedIndices Message

PreAggregatedIndices is a generator of pre-aggregated indices. One pre-aggregated index is generated per combination of resource type, partition label set, filter/group label set, and unique storage aligner (computed from supported aggregations).

NameTypeDescription
namestringName of the group
resource_typesrepeated stringAll resource types in the group
partition_label_setsrepeated MetricDescriptor.Indices.LabelsGroupAll partition label sets. Each is generating index per mentioned resource type, filter/group label set and aligner. Index, to be used, requires specifying all labels mentioned in partition.
filter_and_group_label_setsrepeated MetricDescriptor.Indices.LabelsGroupAll label sets containing labels that can be used in filter/groupBy fields (other than partition). Index, to be used, must not contain any label in filter/groupBy not present in the filter/group labels set.
supported_aggregationsrepeated MetricDescriptor.Indices.AggregationsGroupList of all aggregations required by users.

MetricDescriptor.Indices.NonAggregatedIndices Message

NonAggregatedIndices is a generator of non-aggregated indices. One non-aggregated index is generated per combination of resource type by partition label set.

NameTypeDescription
namestringName of the whole group.
resource_typesrepeated stringResource types in this group.
partition_label_setsrepeated MetricDescriptor.Indices.LabelsGroupAll partition label sets. Each is generating index per mentioned resource type. Index, to be used, requires specifying all labels mentioned in partition.

MetricDescriptor.Indices.PaginationIndices Message

PaginationIndices are special pre-aggregated indices. To access this index, it is necessary to include in the filter some partition label set. Paginable labels MUST not be used in filter, and have no effect in groupBy (always included).

NameTypeDescription
namestringName of the whole group.
resource_typesrepeated stringResource types in this group.
partition_label_setsrepeated MetricDescriptor.Indices.LabelsGroupAll partition label sets. Each is generating index per mentioned resource type. Index, to be used, requires specifying all labels mentioned in partition. Each partition set is matched with each view when generating final views.
viewsrepeated MetricDescriptor.Indices.PaginationViewAll views describing label sets.
functionsrepeated MetricDescriptor.Indices.SortingFunctionList of functions applied to every partition/views in the group.

MetricDescriptor.Indices.IndexGroups Message

Grouped indices

NameTypeDescription
pre_aggregated_indicesrepeated MetricDescriptor.Indices.PreAggregatedIndicesPre-aggregated index sets.
non_aggregated_indicesrepeated MetricDescriptor.Indices.NonAggregatedIndicesNon-aggregated index sets.
pagination_indicesrepeated MetricDescriptor.Indices.PaginationIndicesPagination indices.

MetricDescriptor.BinaryIndices.PreAggregatedIndex Message

NameTypeDescription
key_databytes
writing_alignersrepeated bytes
closed_alignersrepeated bytes

MetricDescriptor.BinaryIndices.PaginatingIndex Message

NameTypeDescription
key_databytes
writing_functionsrepeated bytes
closed_functionsrepeated bytes

MetricDescriptor.BinaryIndices.ByResourceType Message

NameTypeDescription
resource_typestringresource.type in string version, but integer is also encoded in every other item for convenience.
aggs_encoderrepeated bytesList of aggregation encoders, used by streaming job when computing pre-aggregated values. Last item contains most recent version of aggregation. Previous entries will be closed after some time and removed.
pre_aggregated_indicesrepeated MetricDescriptor.BinaryIndices.PreAggregatedIndexList of pre-aggregated indices with per-storage-aligner information. These type of indices are more complex due to presence of aligners with their own liveness status.
paginating_indicesrepeated MetricDescriptor.BinaryIndices.PaginatingIndex
non_aggregated_indicesrepeated bytesNon aggregated indices. Bytes contain identifier with all promoted keys and name part positions.
name_partsrepeated stringindex name parts

BatchGetMetricDescriptorsRequest Message

A request message of the BatchGetMetricDescriptors method.

NameTypeDescription
namesrepeated string (name of MetricDescriptor)Names of MetricDescriptors
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetMetricDescriptorsResponse Message

A response message of the BatchGetMetricDescriptors method.

NameTypeDescription
metric_descriptorsrepeated MetricDescriptorfound MetricDescriptors
missingrepeated string (name of MetricDescriptor)list of not found MetricDescriptors

WatchMetricDescriptorRequest Message

A request message of the WatchMetricDescriptor method.

NameTypeDescription
namestring (name of MetricDescriptor)Name of ntt.monitoring.v4.MetricDescriptor
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchMetricDescriptorResponse Message

A response message of the WatchMetricDescriptor method.

NameTypeDescription
changeMetricDescriptorChange

WatchMetricDescriptorsRequest Message

A request message of the WatchMetricDescriptors method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of MetricDescriptor)Parent name of ntt.monitoring.v4.MetricDescriptor
page_sizeint32Requested page size. Server may return fewer MetricDescriptors than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of MetricDescriptor)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of MetricDescriptor)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of MetricDescriptor)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
[...]
